// Author: Alexander S. Gerasimov

#include <iostream>


// Performs linear search for x in the array vec.
// The lenght of the array is the argument size.
// Two values of the type T are considered equal according to the operator ==.
// Returns a negative integer if x is not found in vec; otherwise returns
// the leftmost index in vec that addresses a value equal to x.
template <typename T> int linSearch(const T vec[], int size, const T& x) {
    for (int k = 0; k < size; k++) {
        if (vec[k] == x) return k;
    }
    return -1;
}


class Int {
private:
    int data;
public:
    Int();
    Int(int i);
    virtual ~Int();
    bool operator==(const Int& x) const;
    void set(int i);
    int get() const;
};


Int::Int() {
    data = 0;
    std::cout<<"Int() \n";
}

Int::Int(int i) {
    data = i;
    std::cout<<"Int("<<i<<")\n";
}

Int::~Int() { // does nothing important, just for test
    std::cout<<"~Int(): data="<<data<<'\n';
}

bool Int::operator==(const Int& x) const {
    return (data == x.data);
}

void Int::set(int i) { data = i; }

int Int::get() const { return data; }


int main() {
    const int DEFAULT_SIZE = 3;
    int size;
    std::cin>>size;
    if (size < 0) size = DEFAULT_SIZE;

    Int* vec1 = new Int[size];
    int* vec2 = new int[size];
    for (int k = 0; k < size; k++) {
        int m;
        std::cin>>m;
        vec1[k].set(m);
        vec2[k] = m;
    }

    int m;
    std::cin>>m;
    Int x(m);

    std::cout<<"Index found in Int[]: "<<linSearch(vec1, size, x)<<'\n';
    std::cout<<"Index found in int[]: "<<linSearch(vec2, size, m)<<'\n';

    delete[] vec1;
    delete[] vec2;
}
